/*
This file is part of web2w.
Copyright 2017 Martin Ruckert

web2w is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

web2w is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with web2w.  If not, see <http://www.gnu.org/licenses/>.
 
Martin Ruckert, Hochschule Muenchen, Lothstrasse 64, 80336 Muenchen
*/
/* A Bison parser, made by GNU Bison 2.7.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2012 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.7"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         pp_parse
#define yylex           pp_lex
#define yyerror         pp_error
#define yylval          pp_lval
#define yychar          pp_char
#define yydebug         pp_debug
#define yynerrs         pp_nerrs

/* Copy the first part of user declarations.  */
/* Line 371 of yacc.c  */
#line 1 "pascal.y"

#include <stdio.h>
#include "web2w.h"

static int function=0;


/* Line 371 of yacc.c  */
#line 83 "pascal.tab.c"

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

/* In a future release of Bison, this section will be replaced
   by #include "pascal.tab.h".  */
#ifndef YY_PP_PASCAL_TAB_H_INCLUDED
# define YY_PP_PASCAL_TAB_H_INCLUDED
/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif
#if YYDEBUG
extern int pp_debug;
#endif
/* "%code requires" blocks.  */
/* Line 387 of yacc.c  */
#line 9 "pascal.y"
 
#define PP_STYPE token *
#define YYSTYPE PP_STYPE

  extern int pp_parse(void);
  extern int pp_debug;
 

/* Line 387 of yacc.c  */
#line 124 "pascal.tab.c"

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     PEOF = 0,
     WEBEOF = 258,
     HEAD = 259,
     BAR = 260,
     PLEFT = 261,
     MLEFT = 262,
     RIGHT = 263,
     OPEN = 264,
     CLOSE = 265,
     TEXT = 266,
     NL = 267,
     HASH = 268,
     NMACRO = 269,
     OMACRO = 270,
     PMACRO = 271,
     PARAM = 272,
     EQ = 273,
     EQEQ = 274,
     ATSTAR = 275,
     ATSPACE = 276,
     ATD = 277,
     ATF = 278,
     ATLESS = 279,
     ATGREATER = 280,
     ELIPSIS = 281,
     ATP = 282,
     OCTAL = 283,
     HEX = 284,
     ATAT = 285,
     ATDOLLAR = 286,
     ATLEFT = 287,
     ATRIGHT = 288,
     ATCTL = 289,
     ATAND = 290,
     ATBACKSLASH = 291,
     ATEX = 292,
     ATQM = 293,
     ATCOMMA = 294,
     ATSLASH = 295,
     ATBAR = 296,
     ATHASH = 297,
     ATPLUS = 298,
     ATSEMICOLON = 299,
     STRING = 300,
     CHAR = 301,
     INDENT = 302,
     METACOMMENT = 303,
     CSEMICOLON = 304,
     ID = 305,
     WDEBUG = 306,
     WSTAT = 307,
     WINIT = 308,
     WTINI = 309,
     WTATS = 310,
     WGUBED = 311,
     PRETURN = 312,
     FIRST_PASCAL_TOKEN = 313,
     PPLUS = 314,
     PMINUS = 315,
     PSTAR = 316,
     PSLASH = 317,
     PEQ = 318,
     PNOTEQ = 319,
     PLESS = 320,
     PGREATER = 321,
     PLESSEQ = 322,
     PGREATEREQ = 323,
     POPEN = 324,
     PCLOSE = 325,
     PSQOPEN = 326,
     PSQCLOSE = 327,
     PASSIGN = 328,
     PDOT = 329,
     PCOMMA = 330,
     PSEMICOLON = 331,
     PMOD = 332,
     PDIV = 333,
     PNIL = 334,
     POR = 335,
     PAND = 336,
     PNOT = 337,
     PIF = 338,
     PTHEN = 339,
     PELSE = 340,
     PREPEAT = 341,
     PUNTIL = 342,
     PWHILE = 343,
     PDO = 344,
     PFOR = 345,
     PTO = 346,
     PDOWNTO = 347,
     PBEGIN = 348,
     PEND = 349,
     PGOTO = 350,
     PINTEGER = 351,
     PREAL = 352,
     POTHERS = 353,
     PSTRING = 354,
     PCHAR = 355,
     PTYPECHAR = 356,
     PTYPEBOOL = 357,
     PTYPEINT = 358,
     PTYPEREAL = 359,
     PTYPEINDEX = 360,
     PID = 361,
     PDEFVARID = 362,
     PDEFPARAMID = 363,
     PDEFREFID = 364,
     PCONSTID = 365,
     PDEFCONSTID = 366,
     PDEFTYPEID = 367,
     PDEFTYPESUBID = 368,
     PARRAYFILETYPEID = 369,
     PARRAYFILEID = 370,
     PFUNCID = 371,
     PDEFFUNCID = 372,
     PPROCID = 373,
     PCALLID = 374,
     PRETURNID = 375,
     PEXIT = 376,
     PFBEGIN = 377,
     PFEND = 378,
     PDOTDOT = 379,
     PCOLON = 380,
     PUP = 381,
     PIN = 382,
     PCASE = 383,
     POF = 384,
     PWITH = 385,
     PCONST = 386,
     PVAR = 387,
     PTYPE = 388,
     PARRAY = 389,
     PRECORD = 390,
     PSET = 391,
     PFILE = 392,
     PFUNCTION = 393,
     PPROCEDURE = 394,
     PLABEL = 395,
     PPACKED = 396,
     PPROGRAM = 397,
     PFORWARD = 398,
     CIGNORE = 399,
     CLABEL = 400,
     CLABELN = 401,
     CINTDEF = 402,
     CSTRDEF = 403,
     CMAIN = 404,
     CMAINEND = 405,
     CUNION = 406,
     CTSUBRANGE = 407,
     CINT = 408,
     CREFID = 409,
     CRETURN = 410,
     CPROCRETURN = 411,
     CCASE = 412,
     CCOLON = 413,
     CBREAK = 414,
     CEMPTY = 415,
     CTLOCAL = 416,
     CTINT = 417
   };
#endif


#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef int YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

extern YYSTYPE pp_lval;

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int pp_parse (void *YYPARSE_PARAM);
#else
int pp_parse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int pp_parse (void);
#else
int pp_parse ();
#endif
#endif /* ! YYPARSE_PARAM */

#endif /* !YY_PP_PASCAL_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

/* Line 390 of yacc.c  */
#line 325 "pascal.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(N) (N)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  5
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   586

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  163
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  102
/* YYNRULES -- Number of rules.  */
#define YYNRULES  257
/* YYNRULES -- Number of states.  */
#define YYNSTATES  465

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   417

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,    10,    14,    20,    21,    25,    27,    31,
      33,    35,    37,    41,    42,    45,    49,    51,    54,    59,
      64,    65,    68,    70,    73,    78,    83,    87,    89,    93,
      97,    99,   102,   105,   107,   109,   111,   116,   121,   123,
     124,   126,   128,   130,   132,   134,   136,   141,   146,   153,
     155,   159,   160,   164,   168,   170,   174,   179,   181,   184,
     191,   200,   202,   204,   206,   216,   226,   234,   242,   250,
     251,   254,   256,   259,   264,   269,   274,   276,   280,   282,
     284,   285,   288,   291,   294,   299,   301,   305,   307,   309,
     313,   314,   317,   319,   322,   327,   332,   337,   342,   344,
     348,   350,   352,   359,   365,   369,   370,   377,   378,   386,
     388,   390,   392,   396,   403,   409,   418,   420,   424,   428,
     430,   434,   436,   439,   444,   449,   451,   453,   458,   463,
     465,   467,   469,   473,   475,   477,   479,   481,   485,   487,
     491,   493,   497,   501,   504,   507,   510,   512,   514,   516,
     518,   522,   524,   526,   528,   530,   532,   534,   536,   537,
     541,   545,   551,   555,   559,   565,   567,   569,   571,   573,
     575,   579,   581,   583,   588,   595,   601,   608,   610,   614,
     618,   621,   624,   627,   628,   633,   634,   639,   641,   643,
     647,   651,   655,   661,   664,   667,   672,   674,   676,   678,
     683,   688,   697,   706,   715,   717,   721,   725,   729,   731,
     733,   735,   737,   739,   741,   743,   748,   753,   758,   762,
     765,   767,   771,   775,   777,   779,   781,   783,   785,   787,
     789,   792,   796,   801,   803,   805,   807,   809,   811,   813,
     817,   819,   821,   823,   825,   827,   829,   831,   835,   837,
     840,   842,   844,   846,   848,   850,   852,   854
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     164,     0,    -1,   165,   166,    93,   224,    94,    74,    -1,
     142,   106,    76,    -1,   167,   170,   174,   194,   199,    -1,
      -1,   140,   168,    76,    -1,   169,    -1,   168,    75,   169,
      -1,    14,    -1,    96,    -1,   121,    -1,   169,    59,    96,
      -1,    -1,   131,   171,    -1,   131,   171,   173,    -1,   172,
      -1,   171,   172,    -1,   106,    63,    96,    76,    -1,   106,
      63,    99,    76,    -1,    -1,   133,   175,    -1,   176,    -1,
     175,   176,    -1,   106,    63,   177,    76,    -1,   106,    63,
     192,    76,    -1,   178,   124,   178,    -1,   179,    -1,   178,
      59,   180,    -1,   178,    60,   180,    -1,   180,    -1,    59,
     180,    -1,    60,   180,    -1,    96,    -1,    14,    -1,   110,
      -1,   182,   137,   129,   184,    -1,   182,   137,   129,   177,
      -1,   141,    -1,    -1,   103,    -1,   104,    -1,   102,    -1,
     101,    -1,   183,    -1,   106,    -1,   182,   135,   186,    94,
      -1,   182,   135,   189,    94,    -1,   182,   135,   186,    76,
     189,    94,    -1,   187,    -1,   186,    76,   187,    -1,    -1,
     188,   125,   192,    -1,   188,   125,   177,    -1,   106,    -1,
     188,    75,   106,    -1,   128,   106,   129,   190,    -1,   191,
      -1,   190,   191,    -1,    96,   125,    69,   187,    70,    76,
      -1,    96,   125,    69,   187,    76,   187,    70,    76,    -1,
     184,    -1,   181,    -1,   185,    -1,   182,   134,    71,   178,
     124,   178,    72,   129,   192,    -1,   182,   134,    71,   178,
     124,   178,    72,   129,   177,    -1,   182,   134,    71,   106,
      72,   129,   192,    -1,   182,   134,    71,   106,    72,   129,
     177,    -1,   182,   134,    71,   101,    72,   129,   192,    -1,
      -1,   132,   195,    -1,   196,    -1,   195,   196,    -1,   197,
     125,   192,    76,    -1,   197,   125,   193,    76,    -1,   197,
     125,   177,    76,    -1,   198,    -1,   197,    75,   198,    -1,
     106,    -1,   154,    -1,    -1,   199,   208,    -1,   199,   209,
      -1,   132,   204,    -1,   140,   201,    76,   203,    -1,   202,
      -1,   201,    75,   202,    -1,    14,    -1,    96,    -1,   169,
      59,    96,    -1,    -1,   132,   204,    -1,   205,    -1,   204,
     205,    -1,   206,   125,   106,    76,    -1,   206,   125,   183,
      76,    -1,   206,   125,   193,    76,    -1,   206,   125,   177,
      76,    -1,   207,    -1,   206,    75,   207,    -1,   106,    -1,
     154,    -1,   213,   200,    93,   224,    94,    76,    -1,   213,
      93,   224,    94,    76,    -1,   213,   143,    76,    -1,    -1,
     214,    93,   210,   224,    94,    76,    -1,    -1,   214,   200,
      93,   211,   224,    94,    76,    -1,   106,    -1,   118,    -1,
     116,    -1,   139,   212,    76,    -1,   139,   212,    69,   215,
      70,    76,    -1,   138,   212,   125,   184,    76,    -1,   138,
     212,    69,   215,    70,   125,   184,    76,    -1,   216,    -1,
     215,    76,   216,    -1,   217,   125,   184,    -1,   218,    -1,
     217,    75,   218,    -1,   207,    -1,   132,   207,    -1,   118,
      69,   221,    70,    -1,   119,    69,   221,    70,    -1,   118,
      -1,   119,    -1,   116,    69,   221,    70,    -1,   119,    69,
     221,    70,    -1,   116,    -1,   119,    -1,   222,    -1,   221,
      75,   222,    -1,   255,    -1,   223,    -1,    45,    -1,    46,
      -1,   255,   125,   255,    -1,   225,    -1,   224,    76,   225,
      -1,   228,    -1,   227,   125,   228,    -1,   121,   125,   228,
      -1,    95,   227,    -1,    95,   121,    -1,   144,   121,    -1,
      57,    -1,    96,    -1,    14,    -1,   145,    -1,    14,    59,
      96,    -1,   229,    -1,   233,    -1,   230,    -1,   231,    -1,
     232,    -1,   226,    -1,   219,    -1,    -1,   251,    73,   255,
      -1,   251,    73,    45,    -1,   251,    73,    69,    45,    70,
      -1,   116,    73,   255,    -1,   155,   144,   255,    -1,   155,
     144,   255,   144,   144,    -1,   155,    -1,   156,    -1,   234,
      -1,   235,    -1,   244,    -1,    93,   224,    94,    -1,   236,
      -1,   237,    -1,    83,   255,    84,   225,    -1,    83,   255,
      84,   225,    85,   225,    -1,   128,   255,   129,   238,    94,
      -1,   128,   255,   129,   238,    76,    94,    -1,   239,    -1,
     238,    76,   239,    -1,   238,   159,   239,    -1,   240,   225,
      -1,    98,   225,    -1,   243,   125,    -1,    -1,   243,    75,
     241,   240,    -1,    -1,   243,   158,   242,   240,    -1,    96,
      -1,    14,    -1,    96,    59,    14,    -1,    14,    59,    14,
      -1,    14,    59,    96,    -1,    14,    60,    14,    59,    14,
      -1,   157,    14,    -1,   157,    96,    -1,   157,    14,    59,
      14,    -1,   245,    -1,   246,    -1,   247,    -1,    88,   255,
      89,   225,    -1,    86,   224,    87,   255,    -1,    90,   106,
      73,   255,    91,   248,    89,   225,    -1,    90,   106,    73,
     255,    91,   178,    89,   225,    -1,    90,   106,    73,   255,
      92,   178,    89,   225,    -1,   251,    -1,   251,    60,   255,
      -1,   251,    59,   255,    -1,   178,    61,   255,    -1,   106,
      -1,   154,    -1,   252,    -1,   253,    -1,   254,    -1,   249,
      -1,   250,    -1,   251,    71,   255,    72,    -1,   251,    71,
      45,    72,    -1,   115,    71,   255,    72,    -1,   251,    74,
     106,    -1,   251,   126,    -1,   257,    -1,   257,   256,   257,
      -1,   257,    63,    45,    -1,    63,    -1,    64,    -1,    65,
      -1,    67,    -1,    66,    -1,    68,    -1,   260,    -1,   258,
     260,    -1,   257,   259,   260,    -1,   257,   259,   258,   260,
      -1,    59,    -1,    60,    -1,    59,    -1,    60,    -1,    80,
      -1,   262,    -1,   260,   261,   262,    -1,    61,    -1,    62,
      -1,    78,    -1,    77,    -1,    81,    -1,   251,    -1,   263,
      -1,    69,   255,    70,    -1,   220,    -1,    82,   262,    -1,
     264,    -1,    96,    -1,    14,    -1,    99,    -1,   100,    -1,
     110,    -1,    97,    -1,    96,    74,    96,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   196,   196,   203,   206,   209,   210,   213,   214,   217,
     218,   219,   220,   223,   224,   225,   228,   229,   232,   237,
     243,   244,   247,   248,   251,   259,   269,   274,   275,   277,
     281,   282,   283,   288,   289,   290,   293,   294,   297,   297,
     299,   300,   301,   302,   304,   305,   309,   311,   313,   318,
     319,   325,   326,   327,   332,   333,   336,   340,   341,   345,
     349,   356,   357,   358,   364,   368,   373,   375,   378,   386,
     387,   390,   391,   394,   396,   398,   403,   404,   407,   408,
     412,   413,   414,   417,   418,   422,   423,   426,   427,   428,
     432,   433,   436,   437,   440,   442,   444,   446,   450,   451,
     454,   455,   462,   465,   467,   470,   470,   473,   473,   484,
     485,   486,   489,   492,   497,   500,   506,   507,   511,   515,
     516,   519,   520,   525,   527,   529,   530,   533,   535,   537,
     538,   542,   543,   548,   549,   550,   551,   555,   558,   559,
     564,   565,   566,   570,   571,   572,   573,   579,   580,   581,
     582,   587,   587,   589,   589,   589,   589,   589,   591,   593,
     594,   595,   599,   600,   601,   603,   604,   608,   608,   608,
     610,   613,   613,   615,   616,   620,   622,   626,   627,   629,
     634,   635,   638,   639,   639,   641,   641,   644,   645,   646,
     647,   648,   649,   651,   652,   653,   657,   657,   657,   659,
     662,   665,   670,   675,   682,   682,   682,   682,   684,   685,
     687,   688,   689,   692,   693,   697,   699,   701,   706,   709,
     712,   713,   715,   719,   719,   719,   719,   719,   719,   721,
     722,   723,   724,   727,   727,   729,   729,   729,   731,   732,
     735,   736,   737,   738,   739,   741,   742,   743,   744,   745,
     749,   750,   751,   752,   753,   754,   757,   758
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 1
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "$undefined", "\"end of web\"", "HEAD",
  "BAR", "PLEFT", "MLEFT", "RIGHT", "OPEN", "CLOSE", "TEXT", "NL", "HASH",
  "NMACRO", "OMACRO", "PMACRO", "PARAM", "EQ", "EQEQ", "ATSTAR", "ATSPACE",
  "ATD", "ATF", "ATLESS", "ATGREATER", "ELIPSIS", "ATP", "OCTAL", "HEX",
  "ATAT", "ATDOLLAR", "ATLEFT", "ATRIGHT", "ATCTL", "ATAND", "ATBACKSLASH",
  "ATEX", "ATQM", "ATCOMMA", "ATSLASH", "ATBAR", "ATHASH", "ATPLUS",
  "ATSEMICOLON", "STRING", "CHAR", "INDENT", "METACOMMENT", "CSEMICOLON",
  "ID", "WDEBUG", "WSTAT", "WINIT", "WTINI", "WTATS", "WGUBED",
  "\"return\"", "FIRST_PASCAL_TOKEN", "\"+\"", "\"-\"", "\"*\"", "\"/\"",
  "\"=\"", "\"<>\"", "\"<\"", "\">\"", "\"<=\"", "\">=\"", "\"(\"",
  "\")\"", "\"[\"", "\"]\"", "\":=\"", "\".\"", "\",\"", "\";\"",
  "\"mod\"", "\"div\"", "\"nil\"", "\"or\"", "\"and\"", "\"not\"",
  "\"if\"", "\"then\"", "\"else\"", "\"repeat\"", "\"until\"", "\"while\"",
  "\"do\"", "\"for\"", "\"to\"", "\"downto\"", "\"begin\"", "\"end\"",
  "\"goto\"", "\"0-9\"", "\"real\"", "\"others\"", "\"'...'\"", "\"'.'\"",
  "\"char type\"", "\"bool type\"", "\"integer type\"", "\"real type\"",
  "\"index type\"", "\"identifier\"", "\"variable definition\"",
  "\"parameter definition\"", "\"reference parameter definition\"",
  "\"constant\"", "\"constant definition\"", "\"typename definition\"",
  "\"subrange typename definition\"", "\"array of file type\"",
  "\"array of file name\"", "\"functionname\"",
  "\"functionname definition\"", "\"procedurename\"", "\"call\"",
  "\"return value\"", "\"final_end\"", "\"function begin\"",
  "\"function end\"", "\"..\"", "\":\"", "\"^\"", "\"in\"", "\"case\"",
  "\"of\"", "\"with\"", "\"const\"", "\"var\"", "\"type\"", "\"array\"",
  "\"record\"", "\"set\"", "\"file\"", "\"function\"", "\"procedure\"",
  "\"label\"", "\"packed\"", "\"program\"", "\"forward\"", "CIGNORE",
  "CLABEL", "CLABELN", "CINTDEF", "CSTRDEF", "CMAIN", "CMAINEND", "CUNION",
  "CTSUBRANGE", "CINT", "\"reference variable\"", "\"C function return\"",
  "\"C procedure return\"", "\"C case\"", "\"C :\"", "\"break\"",
  "\"empty statement\"", "\"local : id\"", "\"int type\"", "$accept",
  "program", "programheading", "globals", "labels", "labellist",
  "labeldecl", "constants", "constdefinitions", "constdefinition",
  "conststringdefinition", "types", "typedefinitions", "typedefinition",
  "subrange", "iconst", "signed_iconst", "simple_iconst", "file_type",
  "packed", "builtin_type", "typename", "record_type", "fields",
  "recordsection", "recids", "variant_part", "variants", "variant", "type",
  "array_type", "variables", "vardeclarations", "vardeclaration", "varids",
  "entire_var", "procedures", "locals", "locallabellist", "locallabeldecl",
  "localvariables", "localvardeclarations", "localvardeclaration",
  "localvarids", "localentire_var", "procedure", "function", "$@1", "$@2",
  "pid", "pheading", "fheading", "formals", "formalparameters", "params",
  "param", "proc_stmt", "function_call", "args", "arg", "write_arg",
  "statements", "statement", "goto_stmt", "label", "stmt", "simple_stmt",
  "empty_stmt", "assign_stmt", "return_stmt", "structured_stmt",
  "compound_stmt", "conditional_stmt", "if_stmt", "case_stmt", "case_list",
  "case_element", "case_labels", "$@3", "$@4", "case_label",
  "repetitive_stmt", "while_stmt", "repeat_stmt", "for_stmt", "varlimit",
  "simple_variable", "compound_variable", "variable", "indexed_var",
  "field_var", "file_var", "expression", "relop", "simple_expr", "sign",
  "addop", "term", "mulop", "factor", "unsigned_const", "real", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   163,   164,   165,   166,   167,   167,   168,   168,   169,
     169,   169,   169,   170,   170,   170,   171,   171,   172,   173,
     174,   174,   175,   175,   176,   176,   177,   178,   178,   178,
     179,   179,   179,   180,   180,   180,   181,   181,   182,   182,
     183,   183,   183,   183,   184,   184,   185,   185,   185,   186,
     186,   187,   187,   187,   188,   188,   189,   190,   190,   191,
     191,   192,   192,   192,   193,   193,   193,   193,   193,   194,
     194,   195,   195,   196,   196,   196,   197,   197,   198,   198,
     199,   199,   199,   200,   200,   201,   201,   202,   202,   202,
     203,   203,   204,   204,   205,   205,   205,   205,   206,   206,
     207,   207,   208,   208,   208,   210,   209,   211,   209,   212,
     212,   212,   213,   213,   214,   214,   215,   215,   216,   217,
     217,   218,   218,   219,   219,   219,   219,   220,   220,   220,
     220,   221,   221,   222,   222,   222,   222,   223,   224,   224,
     225,   225,   225,   226,   226,   226,   226,   227,   227,   227,
     227,   228,   228,   229,   229,   229,   229,   229,   230,   231,
     231,   231,   232,   232,   232,   232,   232,   233,   233,   233,
     234,   235,   235,   236,   236,   237,   237,   238,   238,   238,
     239,   239,   240,   241,   240,   242,   240,   243,   243,   243,
     243,   243,   243,   243,   243,   243,   244,   244,   244,   245,
     246,   247,   247,   247,   248,   248,   248,   248,   249,   249,
     250,   250,   250,   251,   251,   252,   252,   252,   253,   254,
     255,   255,   255,   256,   256,   256,   256,   256,   256,   257,
     257,   257,   257,   258,   258,   259,   259,   259,   260,   260,
     261,   261,   261,   261,   261,   262,   262,   262,   262,   262,
     263,   263,   263,   263,   263,   263,   264,   264
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     6,     3,     5,     0,     3,     1,     3,     1,
       1,     1,     3,     0,     2,     3,     1,     2,     4,     4,
       0,     2,     1,     2,     4,     4,     3,     1,     3,     3,
       1,     2,     2,     1,     1,     1,     4,     4,     1,     0,
       1,     1,     1,     1,     1,     1,     4,     4,     6,     1,
       3,     0,     3,     3,     1,     3,     4,     1,     2,     6,
       8,     1,     1,     1,     9,     9,     7,     7,     7,     0,
       2,     1,     2,     4,     4,     4,     1,     3,     1,     1,
       0,     2,     2,     2,     4,     1,     3,     1,     1,     3,
       0,     2,     1,     2,     4,     4,     4,     4,     1,     3,
       1,     1,     6,     5,     3,     0,     6,     0,     7,     1,
       1,     1,     3,     6,     5,     8,     1,     3,     3,     1,
       3,     1,     2,     4,     4,     1,     1,     4,     4,     1,
       1,     1,     3,     1,     1,     1,     1,     3,     1,     3,
       1,     3,     3,     2,     2,     2,     1,     1,     1,     1,
       3,     1,     1,     1,     1,     1,     1,     1,     0,     3,
       3,     5,     3,     3,     5,     1,     1,     1,     1,     1,
       3,     1,     1,     4,     6,     5,     6,     1,     3,     3,
       2,     2,     2,     0,     4,     0,     4,     1,     1,     3,
       3,     3,     5,     2,     2,     4,     1,     1,     1,     4,
       4,     8,     8,     8,     1,     3,     3,     3,     1,     1,
       1,     1,     1,     1,     1,     4,     4,     4,     3,     2,
       1,     3,     3,     1,     1,     1,     1,     1,     1,     1,
       2,     3,     4,     1,     1,     1,     1,     1,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     3,     1,     2,
       1,     1,     1,     1,     1,     1,     1,     3
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       0,     0,     0,     5,     0,     1,     0,     0,    13,     3,
       9,    10,    11,     0,     7,   158,     0,    20,     0,     6,
       0,   148,   146,     0,   158,     0,     0,   158,     0,   147,
     208,     0,     0,   125,   126,     0,     0,     0,   149,   209,
     165,   166,   157,     0,   138,   156,     0,   140,   151,   153,
     154,   155,   152,   167,   168,   171,   172,   169,   196,   197,
     198,   213,   214,     0,   210,   211,   212,     0,    14,    16,
       0,    69,     8,    12,     0,   252,   233,   234,     0,     0,
     251,   256,   253,   254,   255,   129,   130,   248,   245,     0,
     220,     0,   229,   238,   246,   250,     0,     0,     0,     0,
     144,   143,     0,     0,     0,     0,   158,     0,   145,     0,
     158,     0,   158,     0,     0,     0,   219,     0,     0,    17,
      15,     0,    21,    22,     0,    80,   150,     0,   249,     0,
       0,     0,   158,   235,   236,   223,   224,   225,   227,   226,
     228,   237,     0,     0,   230,   240,   241,   243,   242,   244,
       0,     0,   158,     0,   170,     0,   162,   135,   136,     0,
     131,   134,   133,     0,   142,     0,   163,   139,     2,   141,
       0,     0,   160,     0,   159,   218,     0,     0,    39,    23,
      78,    79,    70,    71,     0,    76,     4,   247,   257,     0,
       0,   173,   222,   221,     0,   231,   239,   200,   199,     0,
     217,   123,     0,     0,   124,   188,   187,   158,     0,     0,
     177,   158,     0,     0,   216,   215,     0,    18,     0,    34,
       0,     0,    33,    43,    42,    40,    41,    45,    35,    38,
       0,     0,    27,    30,    62,     0,    44,    61,    63,     0,
      72,     0,    39,     0,     0,    81,    82,     0,     0,   127,
     128,   158,   232,     0,     0,   132,   137,     0,     0,     0,
     181,   193,   194,     0,   175,     0,   180,   183,   182,   185,
     164,   161,    19,    31,    32,    24,     0,     0,     0,    51,
       0,    25,    77,     0,     0,     0,     0,   109,   111,   110,
       0,     0,   158,     0,     0,     0,     0,   105,     0,   174,
       0,     0,   204,     0,   190,   191,     0,   189,     0,   176,
     178,   179,     0,     0,    28,    29,    26,    54,     0,     0,
      49,     0,     0,     0,    75,     0,    73,    74,     0,     0,
       0,   112,     0,   100,   101,    83,    92,     0,    98,    87,
      88,     0,     0,    85,   104,   158,   158,   107,     0,   158,
     158,     0,     0,   158,     0,   195,   184,   186,     0,    51,
      46,     0,    39,    47,    37,    36,     0,     0,   121,     0,
     116,     0,   119,     0,     0,     0,    93,     0,    39,     0,
       0,    90,     0,     0,   158,   207,   202,   201,   206,   205,
     203,   192,     0,    50,     0,    55,    53,    52,     0,     0,
       0,   122,     0,     0,     0,     0,   114,     0,   103,    99,
       0,     0,     0,     0,     0,    89,    86,     0,    84,     0,
       0,     0,     0,    56,    57,    48,     0,     0,     0,     0,
     117,   120,   118,   113,    94,    97,    95,    96,    91,   102,
     106,     0,     0,    58,    39,    39,     0,     0,   108,    51,
      68,    67,    66,     0,   115,     0,    39,     0,    51,    65,
      64,    59,     0,     0,    60
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,     7,     8,    13,   341,    17,    68,    69,
     120,    71,   122,   123,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   319,   320,   321,   322,   423,   424,   239,
     286,   125,   182,   183,   184,   185,   186,   296,   342,   343,
     418,   335,   336,   337,   338,   245,   246,   346,   384,   290,
     247,   248,   369,   370,   371,   372,    42,    87,   159,   160,
     161,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,   209,   210,   211,   312,   313,
     212,    57,    58,    59,    60,   301,    61,    62,    88,    64,
      65,    66,   162,   142,    90,    91,   143,    92,   150,    93,
      94,    95
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -319
static const yytype_int16 yypact[] =
{
     -88,   -29,   130,   -59,    64,  -319,     6,    74,    70,  -319,
    -319,  -319,  -319,   261,   144,   138,   104,    92,     6,  -319,
     152,   206,  -319,   348,   138,   348,   162,   138,    28,  -319,
    -319,   218,   233,   259,   264,   188,   348,   243,  -319,  -319,
     216,  -319,  -319,   -28,  -319,  -319,   245,  -319,  -319,  -319,
    -319,  -319,  -319,  -319,  -319,  -319,  -319,  -319,  -319,  -319,
    -319,  -319,  -319,   106,  -319,  -319,  -319,   316,   280,  -319,
     289,   269,   144,  -319,   308,  -319,  -319,  -319,   348,    59,
     335,  -319,  -319,  -319,  -319,   341,   344,  -319,    89,   331,
     506,    59,   226,  -319,  -319,  -319,   -36,   329,   346,    -5,
    -319,  -319,   348,   348,    16,    16,   408,   285,  -319,   348,
     138,   349,   408,   202,   281,   314,  -319,   328,   364,  -319,
    -319,   365,   289,  -319,    76,  -319,  -319,   359,  -319,   343,
      16,    16,   138,  -319,  -319,   396,  -319,  -319,  -319,  -319,
    -319,  -319,   348,   348,   226,  -319,  -319,  -319,  -319,  -319,
      59,   348,   138,   348,  -319,   370,  -319,  -319,  -319,   176,
    -319,  -319,   321,   244,  -319,    11,   299,  -319,  -319,  -319,
     377,   379,  -319,   306,  -319,  -319,   374,   124,   330,  -319,
    -319,  -319,    76,  -319,   -47,  -319,   220,  -319,  -319,   254,
     257,   367,  -319,   -10,    59,   226,  -319,  -319,  -319,   276,
    -319,  -319,    16,   348,  -319,   323,   394,   138,    25,   -53,
    -319,   138,   -62,   311,  -319,  -319,   386,  -319,   381,  -319,
      38,    38,  -319,  -319,  -319,  -319,  -319,  -319,  -319,  -319,
     385,   -38,  -319,  -319,  -319,   -92,  -319,  -319,  -319,   390,
    -319,    76,   330,    96,    96,  -319,  -319,   -60,   165,  -319,
    -319,   138,   226,    51,   215,  -319,  -319,    33,   448,   454,
    -319,   410,  -319,    -6,  -319,    11,  -319,  -319,  -319,  -319,
    -319,  -319,  -319,  -319,  -319,  -319,    38,    38,   215,   -69,
     347,  -319,  -319,   397,   211,   399,   401,  -319,  -319,  -319,
     -51,   -16,   138,    81,    12,   402,   392,  -319,   393,  -319,
     -25,   383,   126,    -2,  -319,  -319,   411,  -319,   469,  -319,
    -319,  -319,     5,     5,  -319,  -319,   325,  -319,   384,    95,
    -319,   -46,   395,   445,  -319,   416,  -319,  -319,    44,   251,
      44,  -319,   115,  -319,  -319,    81,  -319,    97,  -319,   433,
     434,   436,   318,  -319,  -319,   138,   138,  -319,   348,   138,
     138,   348,   348,   138,   483,  -319,  -319,  -319,   371,   -69,
    -319,   400,   330,  -319,  -319,  -319,   190,    81,  -319,   200,
    -319,   118,  -319,   423,   203,   431,  -319,    81,   378,   412,
      12,   380,   184,   191,   138,  -319,  -319,  -319,  -319,  -319,
    -319,  -319,   413,  -319,   417,  -319,  -319,  -319,   438,   441,
      94,  -319,   391,    44,    44,   251,  -319,   439,  -319,  -319,
     442,   444,   387,   446,   449,   458,  -319,    81,  -319,   452,
     453,   196,   405,   413,  -319,  -319,   403,   404,   215,   251,
    -319,  -319,  -319,  -319,  -319,  -319,  -319,  -319,    81,  -319,
    -319,   455,   465,  -319,   270,   330,    -4,   459,  -319,   432,
    -319,  -319,  -319,   414,  -319,   239,   330,   461,   432,  -319,
    -319,  -319,   470,   463,  -319
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -319,  -319,  -319,  -319,  -319,  -319,   193,  -319,  -319,   474,
    -319,  -319,  -319,   422,  -239,  -247,  -319,   -37,  -319,  -232,
     167,  -291,  -319,  -319,  -313,  -319,   194,  -319,   127,  -237,
     178,  -319,  -319,   372,  -319,   317,  -319,   309,  -319,   179,
    -319,   143,  -318,  -319,  -140,  -319,  -319,  -319,  -319,   324,
    -319,  -319,   231,   164,  -319,   171,  -319,  -319,   150,   375,
    -319,   -23,  -108,  -319,   548,   204,  -319,  -319,  -319,  -319,
    -319,  -319,  -319,  -319,  -319,  -319,    84,    86,  -319,  -319,
    -319,  -319,  -319,  -319,  -319,  -319,  -319,  -319,   -15,  -319,
    -319,  -319,    -9,  -319,   437,   435,  -319,   -76,  -319,   -68,
    -319,  -319
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -13
static const yytype_int16 yytable[] =
{
      63,    96,   167,   283,    99,   285,   300,   303,   205,    63,
     284,   128,    63,   267,    89,   144,    97,   376,   328,   205,
      10,   276,   277,   263,   191,   205,   339,   107,   241,   361,
      75,   316,   365,   292,   276,   277,   348,   317,   373,   261,
     110,   264,    21,   279,   198,   280,   393,   304,   110,   133,
     134,   151,   219,   330,     1,   276,   277,   276,   277,   318,
     331,   157,   158,   268,   349,   219,   111,   195,   453,   127,
     141,   110,   293,    75,   329,    76,    77,     4,   242,   362,
     294,     6,   196,   295,   364,    78,   278,   353,   309,   154,
     206,    63,   207,   155,   156,    63,   269,    63,    79,   260,
     166,   206,    11,   266,   171,   174,   265,   206,   340,   207,
     220,   221,    80,    81,   432,    82,    83,    63,   252,   400,
     376,   262,    30,   396,    29,   397,    84,    12,    78,   305,
       5,    31,    85,    12,   222,    86,   455,    63,   447,   411,
       9,    79,   197,   299,   199,   462,   412,   222,   228,   100,
     333,   208,    21,   276,   277,    80,    81,    30,    82,    83,
     113,   228,   208,   115,   127,    30,    31,    15,   208,    84,
      39,   359,   377,    38,    31,    85,   367,   113,    86,   114,
     115,   446,   180,   273,   274,   351,   352,   333,   368,   360,
     368,   110,    63,   404,   256,    22,    63,   113,   334,    14,
     115,    16,   287,    20,   219,    39,   451,   450,   452,   375,
      67,    72,   288,    39,   289,   116,    75,   459,   428,   460,
     176,    23,   378,   218,    24,    70,    25,   401,    26,   219,
     181,    27,   116,    28,    29,   334,    63,   409,   302,   314,
     315,   386,   387,   405,    30,   390,   201,   170,    73,   220,
     221,   202,   116,    31,    32,   163,    33,    34,   297,    35,
     110,    76,    77,   368,   368,    74,    36,   110,    98,   332,
     402,    78,   110,   407,   220,   221,   403,    63,   419,   403,
     189,   190,    37,    38,    79,   420,   222,   145,   146,   102,
     441,   398,    39,    40,    41,    75,   399,   293,    80,    81,
     228,    82,    83,   147,   148,   294,   103,   149,    30,   457,
     164,   222,    84,   106,   204,   458,   169,    31,    85,   202,
      75,    86,   382,   383,   249,   228,   172,   250,   104,   202,
      63,    63,   202,   105,    63,    63,    18,    19,    63,   385,
      76,    77,   388,   389,   219,   325,   279,   310,   280,   311,
     173,   216,   223,   224,   225,   226,    39,   227,   243,   244,
     109,   421,    75,    79,   108,    76,    77,   253,   254,    63,
     112,   223,   224,   225,   226,    78,   227,    80,    81,   117,
      82,    83,   257,   258,   276,   277,   118,    30,    79,   220,
     221,    84,   219,   380,   381,   121,    31,    85,   356,   357,
      86,   124,    80,    81,   126,    82,    83,    76,    77,   129,
     130,   229,    30,   131,   165,   132,    84,    78,   152,   153,
     175,    31,    85,   168,   176,    86,   222,   177,   178,   187,
      79,   223,   224,   225,   226,    39,   227,   220,   221,   188,
     228,   192,   200,   213,    80,    81,   203,    82,    83,   214,
     217,   215,   251,   259,    30,   270,   271,   272,    84,   219,
      39,   275,   306,    31,    85,    22,   281,    86,   307,   308,
     354,   229,   350,   324,   222,   326,   323,   327,   344,   223,
     224,   225,   226,   355,   410,   345,   347,   366,   228,   363,
     358,    23,    -9,   -10,    24,   379,    25,   391,    26,   406,
     392,    27,    39,    28,   220,   221,   395,   408,   415,   422,
     426,   425,   417,   427,    30,   433,   429,   -12,   434,   229,
     435,   325,   436,    31,    32,   437,    33,    34,   439,   440,
     442,   448,   444,   445,   449,   454,    36,   461,   317,   464,
     463,   222,   119,   456,   179,   413,   223,   224,   225,   226,
     443,   227,    37,   394,   240,   228,   414,   298,   282,   416,
     438,   374,    39,    40,    41,   133,   134,   430,   291,   135,
     136,   137,   138,   139,   140,   431,   101,   255,   194,   193,
       0,     0,     0,     0,     0,     0,   141
};

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-319)))

#define yytable_value_is_error(Yytable_value) \
  YYID (0)

static const yytype_int16 yycheck[] =
{
      15,    24,   110,   242,    27,   242,   253,   254,    14,    24,
     242,    79,    27,    75,    23,    91,    25,   335,    69,    14,
      14,    59,    60,    76,   132,    14,    14,    36,    75,    75,
      14,   278,   323,    93,    59,    60,    61,   106,   329,    14,
      76,    94,    14,   135,   152,   137,   359,    14,    76,    59,
      60,    87,    14,    69,   142,    59,    60,    59,    60,   128,
      76,    45,    46,   125,    89,    14,    94,   143,    72,    78,
      80,    76,   132,    14,   125,    59,    60,   106,   125,   125,
     140,   140,   150,   143,   323,    69,   124,    89,    94,    94,
      96,   106,    98,   102,   103,   110,   158,   112,    82,   207,
     109,    96,    96,   211,   113,   114,   159,    96,    96,    98,
      59,    60,    96,    97,   405,    99,   100,   132,   194,   366,
     438,    96,   106,   362,    96,   362,   110,   121,    69,    96,
       0,   115,   116,   121,    96,   119,   449,   152,   429,   378,
      76,    82,   151,   251,   153,   458,   378,    96,   110,   121,
     106,   157,    14,    59,    60,    96,    97,   106,    99,   100,
      71,   110,   157,    74,   173,   106,   115,    93,   157,   110,
     154,    76,    75,   145,   115,   116,   132,    71,   119,    73,
      74,   428,   106,   220,   221,    59,    60,   106,   328,    94,
     330,    76,   207,    75,   203,    57,   211,    71,   154,     6,
      74,   131,   106,    59,    14,   154,   445,   444,   445,    94,
     106,    18,   116,   154,   118,   126,    14,   456,   124,   456,
      96,    83,   125,    99,    86,   133,    88,   367,    90,    14,
     154,    93,   126,    95,    96,   154,   251,   377,   253,   276,
     277,   349,   350,   125,   106,   353,    70,    45,    96,    59,
      60,    75,   126,   115,   116,   105,   118,   119,    93,   121,
      76,    59,    60,   403,   404,    59,   128,    76,   106,   292,
      70,    69,    76,    70,    59,    60,    76,   292,    94,    76,
     130,   131,   144,   145,    82,    94,    96,    61,    62,    71,
      94,   101,   154,   155,   156,    14,   106,   132,    96,    97,
     110,    99,   100,    77,    78,   140,    73,    81,   106,    70,
     106,    96,   110,   125,    70,    76,   112,   115,   116,    75,
      14,   119,   345,   346,    70,   110,    45,    70,    69,    75,
     345,   346,    75,    69,   349,   350,    75,    76,   353,   348,
      59,    60,   351,   352,    14,   134,   135,   263,   137,   265,
      69,    45,   101,   102,   103,   104,   154,   106,   138,   139,
     144,   384,    14,    82,   121,    59,    60,    91,    92,   384,
     125,   101,   102,   103,   104,    69,   106,    96,    97,    63,
      99,   100,    59,    60,    59,    60,   106,   106,    82,    59,
      60,   110,    14,    75,    76,   106,   115,   116,   312,   313,
     119,   132,    96,    97,    96,    99,   100,    59,    60,    74,
      69,   141,   106,    69,   129,    84,   110,    69,    89,    73,
     106,   115,   116,    74,    96,   119,    96,    63,    63,    70,
      82,   101,   102,   103,   104,   154,   106,    59,    60,    96,
     110,    45,    72,   144,    96,    97,   125,    99,   100,    72,
      76,    72,    85,    59,   106,   144,    70,    76,   110,    14,
     154,    76,    14,   115,   116,    57,    76,   119,    14,    59,
      59,   141,    89,    76,    96,    76,   129,    76,    76,   101,
     102,   103,   104,    14,   106,    93,    93,    71,   110,    94,
     106,    83,    59,    59,    86,    59,    88,    14,    90,    76,
     129,    93,   154,    95,    59,    60,   106,    76,    96,    96,
      72,    94,   132,    72,   106,    76,   125,    59,    76,   141,
      76,   134,    76,   115,   116,    76,   118,   119,    76,    76,
     125,    76,   129,   129,    69,    76,   128,    76,   106,    76,
      70,    96,    68,   129,   122,   378,   101,   102,   103,   104,
     423,   106,   144,   359,   182,   110,   378,   248,   241,   380,
     417,   330,   154,   155,   156,    59,    60,   403,   244,    63,
      64,    65,    66,    67,    68,   404,    28,   202,   143,   142,
      -1,    -1,    -1,    -1,    -1,    -1,    80
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,   142,   164,   165,   106,     0,   140,   166,   167,    76,
      14,    96,   121,   168,   169,    93,   131,   170,    75,    76,
      59,    14,    57,    83,    86,    88,    90,    93,    95,    96,
     106,   115,   116,   118,   119,   121,   128,   144,   145,   154,
     155,   156,   219,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   244,   245,   246,
     247,   249,   250,   251,   252,   253,   254,   106,   171,   172,
     133,   174,   169,    96,    59,    14,    59,    60,    69,    82,
      96,    97,    99,   100,   110,   116,   119,   220,   251,   255,
     257,   258,   260,   262,   263,   264,   224,   255,   106,   224,
     121,   227,    71,    73,    69,    69,   125,   255,   121,   144,
      76,    94,   125,    71,    73,    74,   126,    63,   106,   172,
     173,   106,   175,   176,   132,   194,    96,   255,   262,    74,
      69,    69,    84,    59,    60,    63,    64,    65,    66,    67,
      68,    80,   256,   259,   260,    61,    62,    77,    78,    81,
     261,    87,    89,    73,    94,   255,   255,    45,    46,   221,
     222,   223,   255,   221,   228,   129,   255,   225,    74,   228,
      45,   255,    45,    69,   255,   106,    96,    63,    63,   176,
     106,   154,   195,   196,   197,   198,   199,    70,    96,   221,
     221,   225,    45,   257,   258,   260,   262,   255,   225,   255,
      72,    70,    75,   125,    70,    14,    96,    98,   157,   238,
     239,   240,   243,   144,    72,    72,    45,    76,    99,    14,
      59,    60,    96,   101,   102,   103,   104,   106,   110,   141,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   192,
     196,    75,   125,   138,   139,   208,   209,   213,   214,    70,
      70,    85,   260,    91,    92,   222,   255,    59,    60,    59,
     225,    14,    96,    76,    94,   159,   225,    75,   125,   158,
     144,    70,    76,   180,   180,    76,    59,    60,   124,   135,
     137,    76,   198,   177,   182,   192,   193,   106,   116,   118,
     212,   212,    93,   132,   140,   143,   200,    93,   200,   225,
     178,   248,   251,   178,    14,    96,    14,    14,    59,    94,
     239,   239,   241,   242,   180,   180,   178,   106,   128,   186,
     187,   188,   189,   129,    76,   134,    76,    76,    69,   125,
      69,    76,   224,   106,   154,   204,   205,   206,   207,    14,
      96,   169,   201,   202,    76,    93,   210,    93,    61,    89,
      89,    59,    60,    89,    59,    14,   240,   240,   106,    76,
      94,    75,   125,    94,   177,   184,    71,   132,   207,   215,
     216,   217,   218,   184,   215,    94,   205,    75,   125,    59,
      75,    76,   224,   224,   211,   255,   225,   225,   255,   255,
     225,    14,   129,   187,   189,   106,   177,   192,   101,   106,
     178,   207,    70,    76,    75,   125,    76,    70,    76,   207,
     106,   177,   182,   183,   193,    96,   202,   132,   203,    94,
      94,   224,    96,   190,   191,    94,    72,    72,   124,   125,
     216,   218,   184,    76,    76,    76,    76,    76,   204,    76,
      76,    94,   125,   191,   129,   129,   178,   184,    76,    69,
     192,   177,   192,    72,    76,   187,   129,    70,    76,   177,
     192,    76,   187,    70,    76
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))

/* Error token number */
#define YYTERROR	1
#define YYERRCODE	256


/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */
#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
        break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULL, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULL;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULL, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}




/* The lookahead symbol.  */
int yychar;


#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval YY_INITIAL_VALUE(yyval_default);

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
/* Line 1792 of yacc.c  */
#line 198 "pascal.y"
    { CHGTAG((yyvsp[(3) - (6)]),CMAIN); CHGTAG((yyvsp[(5) - (6)]),CMAINEND); IGN((yyvsp[(6) - (6)])); 
           wsemicolon((yyvsp[(4) - (6)]),(yyvsp[(5) - (6)]));
         }
    break;

  case 3:
/* Line 1792 of yacc.c  */
#line 203 "pascal.y"
    { LNK((yyvsp[(1) - (3)]),(yyvsp[(3) - (3)])); }
    break;

  case 6:
/* Line 1792 of yacc.c  */
#line 210 "pascal.y"
    { IGN((yyvsp[(3) - (3)])); }
    break;

  case 8:
/* Line 1792 of yacc.c  */
#line 214 "pascal.y"
    { IGN((yyvsp[(2) - (3)])); }
    break;

  case 9:
/* Line 1792 of yacc.c  */
#line 217 "pascal.y"
    {IGN((yyvsp[(1) - (1)])); SYM((yyvsp[(1) - (1)]))->scan_count--;}
    break;

  case 10:
/* Line 1792 of yacc.c  */
#line 218 "pascal.y"
    {IGN((yyvsp[(1) - (1)])); }
    break;

  case 11:
/* Line 1792 of yacc.c  */
#line 219 "pascal.y"
    {IGN((yyvsp[(1) - (1)])); }
    break;

  case 12:
/* Line 1792 of yacc.c  */
#line 220 "pascal.y"
    {IGN((yyvsp[(2) - (3)])); IGN((yyvsp[(3) - (3)])); }
    break;

  case 18:
/* Line 1792 of yacc.c  */
#line 232 "pascal.y"
    { LNK((yyvsp[(2) - (4)]),(yyvsp[(4) - (4)]));  
                   SETVAL((yyvsp[(1) - (4)]),getval((yyvsp[(3) - (4)]))); CHGID((yyvsp[(1) - (4)]),PCONSTID);
                   CHGTAG((yyvsp[(1) - (4)]),CINTDEF); CHGTAG((yyvsp[(2) - (4)]),PASSIGN); CHGTAG((yyvsp[(4) - (4)]),PCOMMA); }
    break;

  case 19:
/* Line 1792 of yacc.c  */
#line 238 "pascal.y"
    { seq((yyvsp[(1) - (4)]),(yyvsp[(4) - (4)])); LNK((yyvsp[(1) - (4)]),(yyvsp[(4) - (4)]));CHGID((yyvsp[(1) - (4)]),PCONSTID);
                 CHGTAG((yyvsp[(1) - (4)]),CSTRDEF);CHGTAG((yyvsp[(2) - (4)]),PASSIGN); }
    break;

  case 21:
/* Line 1792 of yacc.c  */
#line 244 "pascal.y"
    { IGN((yyvsp[(1) - (2)])); }
    break;

  case 24:
/* Line 1792 of yacc.c  */
#line 252 "pascal.y"
    { DBG(dbgparse,"New Subrange Type: %s\n",
						  SYM((yyvsp[(1) - (4)]))->name);
                                              LNK((yyvsp[(1) - (4)]),(yyvsp[(2) - (4)])); IGN((yyvsp[(2) - (4)]));LNK((yyvsp[(2) - (4)]),(yyvsp[(4) - (4)]));
                                              CHGTYPE((yyvsp[(1) - (4)]),(yyvsp[(3) - (4)])); 
                                              CHGTAG((yyvsp[(1) - (4)]),PDEFTYPEID);
                                              CHGTAG((yyvsp[(2) - (4)]),CTSUBRANGE); UP((yyvsp[(2) - (4)]),(yyvsp[(3) - (4)]));
                                             }
    break;

  case 25:
/* Line 1792 of yacc.c  */
#line 260 "pascal.y"
    { DBG(dbgparse,"New Type: %s\n",
					      SYM((yyvsp[(1) - (4)]))->name);
                                              LNK((yyvsp[(1) - (4)]),(yyvsp[(2) - (4)])); IGN((yyvsp[(2) - (4)])); LNK((yyvsp[(2) - (4)]),(yyvsp[(4) - (4)])); 
                                              CHGTYPE((yyvsp[(1) - (4)]),(yyvsp[(3) - (4)])); LNK((yyvsp[(3) - (4)]),(yyvsp[(4) - (4)]));
                                              CHGTAG((yyvsp[(1) - (4)]),PDEFTYPEID);
                                            }
    break;

  case 26:
/* Line 1792 of yacc.c  */
#line 270 "pascal.y"
    {(yyval)=join(PDOTDOT,(yyvsp[(1) - (3)]),(yyvsp[(3) - (3)]),(yyvsp[(3) - (3)])->value-(yyvsp[(1) - (3)])->value+1); }
    break;

  case 27:
/* Line 1792 of yacc.c  */
#line 274 "pascal.y"
    {(yyval)=(yyvsp[(1) - (1)]); }
    break;

  case 28:
/* Line 1792 of yacc.c  */
#line 276 "pascal.y"
    {(yyval)=join(PPLUS,(yyvsp[(1) - (3)]),(yyvsp[(3) - (3)]),(yyvsp[(1) - (3)])->value+(yyvsp[(3) - (3)])->value); }
    break;

  case 29:
/* Line 1792 of yacc.c  */
#line 278 "pascal.y"
    {(yyval)=join(PMINUS,(yyvsp[(1) - (3)]),(yyvsp[(3) - (3)]),(yyvsp[(1) - (3)])->value-(yyvsp[(3) - (3)])->value); }
    break;

  case 30:
/* Line 1792 of yacc.c  */
#line 281 "pascal.y"
    {(yyval)=(yyvsp[(1) - (1)]); }
    break;

  case 31:
/* Line 1792 of yacc.c  */
#line 282 "pascal.y"
    {(yyval)=join(PPLUS,NULL,(yyvsp[(2) - (2)]),(yyvsp[(2) - (2)])->value); }
    break;

  case 32:
/* Line 1792 of yacc.c  */
#line 284 "pascal.y"
    {(yyval)=join(PMINUS,NULL,(yyvsp[(2) - (2)]),-((yyvsp[(2) - (2)])->value)); }
    break;

  case 33:
/* Line 1792 of yacc.c  */
#line 288 "pascal.y"
    {(yyval)=join(PINTEGER,(yyvsp[(1) - (1)]),NULL,getval((yyvsp[(1) - (1)]))); }
    break;

  case 34:
/* Line 1792 of yacc.c  */
#line 289 "pascal.y"
    {(yyval)=join(NMACRO,(yyvsp[(1) - (1)]),NULL,getval((yyvsp[(1) - (1)]))); USE_NMACRO((yyvsp[(1) - (1)])); }
    break;

  case 35:
/* Line 1792 of yacc.c  */
#line 290 "pascal.y"
    {(yyval)=join(PCONSTID,(yyvsp[(1) - (1)]),NULL,getval((yyvsp[(1) - (1)]))); }
    break;

  case 36:
/* Line 1792 of yacc.c  */
#line 293 "pascal.y"
    {(yyval)=(yyvsp[(2) - (4)]); }
    break;

  case 37:
/* Line 1792 of yacc.c  */
#line 294 "pascal.y"
    {(yyval)=(yyvsp[(2) - (4)]); }
    break;

  case 44:
/* Line 1792 of yacc.c  */
#line 304 "pascal.y"
    {(yyval)=NULL; }
    break;

  case 45:
/* Line 1792 of yacc.c  */
#line 305 "pascal.y"
    {(yyval)=NULL; }
    break;

  case 46:
/* Line 1792 of yacc.c  */
#line 309 "pascal.y"
    { LNK((yyvsp[(2) - (4)]),(yyvsp[(4) - (4)])); LNK((yyvsp[(3) - (4)]),(yyvsp[(4) - (4)]));  
                                        if ((yyvsp[(3) - (4)])) CHGTAG((yyvsp[(4) - (4)]),PSEMICOLON); else IGN((yyvsp[(4) - (4)])); (yyval)=NULL; }
    break;

  case 47:
/* Line 1792 of yacc.c  */
#line 312 "pascal.y"
    { LNK((yyvsp[(2) - (4)]),(yyvsp[(4) - (4)])); LNK((yyvsp[(3) - (4)]),(yyvsp[(4) - (4)]));  IGN((yyvsp[(4) - (4)])); (yyval)=NULL; }
    break;

  case 48:
/* Line 1792 of yacc.c  */
#line 314 "pascal.y"
    { LNK((yyvsp[(2) - (6)]),(yyvsp[(6) - (6)])); LNK((yyvsp[(3) - (6)]),(yyvsp[(4) - (6)])); LNK((yyvsp[(5) - (6)]),(yyvsp[(6) - (6)])); IGN((yyvsp[(6) - (6)])); (yyval)=NULL; }
    break;

  case 49:
/* Line 1792 of yacc.c  */
#line 318 "pascal.y"
    {(yyval)=(yyvsp[(1) - (1)]); }
    break;

  case 50:
/* Line 1792 of yacc.c  */
#line 319 "pascal.y"
    { LNK((yyvsp[(1) - (3)]),(yyvsp[(2) - (3)])); (yyval)=(yyvsp[(3) - (3)]); }
    break;

  case 51:
/* Line 1792 of yacc.c  */
#line 325 "pascal.y"
    {(yyval)=NULL; }
    break;

  case 52:
/* Line 1792 of yacc.c  */
#line 326 "pascal.y"
    {LNK((yyvsp[(1) - (3)]),(yyvsp[(2) - (3)])); IGN((yyvsp[(2) - (3)])); (yyval)=(yyvsp[(2) - (3)]); }
    break;

  case 53:
/* Line 1792 of yacc.c  */
#line 328 "pascal.y"
    {LNK((yyvsp[(1) - (3)]),(yyvsp[(2) - (3)])); CHGTAG((yyvsp[(2) - (3)]),CTSUBRANGE); UP((yyvsp[(2) - (3)]),(yyvsp[(3) - (3)])); (yyval)=(yyvsp[(2) - (3)]); }
    break;

  case 54:
/* Line 1792 of yacc.c  */
#line 332 "pascal.y"
    {(yyval)=(yyvsp[(1) - (1)]);  CHGTAG((yyvsp[(1) - (1)]),PDEFVARID); }
    break;

  case 55:
/* Line 1792 of yacc.c  */
#line 333 "pascal.y"
    {(yyval)=(yyvsp[(1) - (3)]); }
    break;

  case 56:
/* Line 1792 of yacc.c  */
#line 336 "pascal.y"
    {IGN((yyvsp[(1) - (4)]));IGN((yyvsp[(2) - (4)])); 
                                       CHGTAG((yyvsp[(3) - (4)]),CUNION); (yyval)=(yyvsp[(3) - (4)]); }
    break;

  case 59:
/* Line 1792 of yacc.c  */
#line 346 "pascal.y"
    { IGN((yyvsp[(1) - (6)])); IGN((yyvsp[(2) - (6)])); IGN((yyvsp[(3) - (6)])); 
                   LNK((yyvsp[(4) - (6)]),(yyvsp[(5) - (6)])); 
                   IGN((yyvsp[(5) - (6)])); }
    break;

  case 60:
/* Line 1792 of yacc.c  */
#line 351 "pascal.y"
    { IGN((yyvsp[(1) - (8)])); IGN((yyvsp[(2) - (8)])); CHGTAG((yyvsp[(3) - (8)]),PRECORD);  
                   LNK((yyvsp[(3) - (8)]),(yyvsp[(8) - (8)])); LNK((yyvsp[(4) - (8)]),(yyvsp[(5) - (8)])); LNK((yyvsp[(6) - (8)]),(yyvsp[(7) - (8)])); CHGTAG((yyvsp[(7) - (8)]),PSEMICOLON); }
    break;

  case 64:
/* Line 1792 of yacc.c  */
#line 365 "pascal.y"
    {LNK((yyvsp[(2) - (9)]),(yyvsp[(3) - (9)])); 
                 UP((yyvsp[(2) - (9)]),join(PDOTDOT,(yyvsp[(4) - (9)]),(yyvsp[(6) - (9)]),(yyvsp[(6) - (9)])->value-(yyvsp[(4) - (9)])->value+1)); 
                 LNK((yyvsp[(3) - (9)]),(yyvsp[(5) - (9)])); LNK((yyvsp[(5) - (9)]),(yyvsp[(7) - (9)])); LNK((yyvsp[(7) - (9)]),(yyvsp[(8) - (9)]));(yyval)=(yyvsp[(8) - (9)]); }
    break;

  case 65:
/* Line 1792 of yacc.c  */
#line 369 "pascal.y"
    {LNK((yyvsp[(2) - (9)]),(yyvsp[(3) - (9)])); 
                 UP((yyvsp[(2) - (9)]),join(PDOTDOT,(yyvsp[(4) - (9)]),(yyvsp[(6) - (9)]),(yyvsp[(6) - (9)])->value-(yyvsp[(4) - (9)])->value+1)); 
                 LNK((yyvsp[(3) - (9)]),(yyvsp[(5) - (9)])); LNK((yyvsp[(5) - (9)]),(yyvsp[(7) - (9)])); LNK((yyvsp[(7) - (9)]),(yyvsp[(8) - (9)]));
                 CHGTAG((yyvsp[(8) - (9)]),CTSUBRANGE); UP((yyvsp[(8) - (9)]),(yyvsp[(9) - (9)]));(yyval)=(yyvsp[(8) - (9)]); }
    break;

  case 66:
/* Line 1792 of yacc.c  */
#line 373 "pascal.y"
    {LNK((yyvsp[(2) - (7)]),(yyvsp[(3) - (7)])); 
                 UP((yyvsp[(2) - (7)]),(yyvsp[(4) - (7)]));LNK((yyvsp[(3) - (7)]),(yyvsp[(4) - (7)])); LNK((yyvsp[(4) - (7)]),(yyvsp[(5) - (7)])); LNK((yyvsp[(5) - (7)]),(yyvsp[(6) - (7)]));(yyval)=(yyvsp[(6) - (7)]); }
    break;

  case 67:
/* Line 1792 of yacc.c  */
#line 376 "pascal.y"
    {LNK((yyvsp[(2) - (7)]),(yyvsp[(3) - (7)])); UP((yyvsp[(2) - (7)]),(yyvsp[(4) - (7)])); LNK((yyvsp[(3) - (7)]),(yyvsp[(4) - (7)])); LNK((yyvsp[(4) - (7)]),(yyvsp[(5) - (7)])); 
              LNK((yyvsp[(5) - (7)]),(yyvsp[(6) - (7)])); CHGTAG((yyvsp[(6) - (7)]),CTSUBRANGE); UP((yyvsp[(6) - (7)]),(yyvsp[(7) - (7)]));(yyval)=(yyvsp[(6) - (7)]); }
    break;

  case 68:
/* Line 1792 of yacc.c  */
#line 379 "pascal.y"
    {LNK((yyvsp[(2) - (7)]),(yyvsp[(3) - (7)])); UP((yyvsp[(2) - (7)]),join(PDOTDOT,
            join(PTYPECHAR,(yyvsp[(1) - (7)]),(yyvsp[(1) - (7)]),0),join(PTYPECHAR,(yyvsp[(1) - (7)]),(yyvsp[(1) - (7)]),255),256)); 
            (yyvsp[(3) - (7)])->link=join(PTYPECHAR,(yyvsp[(3) - (7)]),(yyvsp[(5) - (7)]),256); (yyvsp[(3) - (7)])->link->link=(yyvsp[(5) - (7)]); 
             /* the PTYPECHAR comes from a macroexpansion, so we can not 
             link it directly */ LNK((yyvsp[(5) - (7)]),(yyvsp[(6) - (7)])); (yyval)=(yyvsp[(6) - (7)]); }
    break;

  case 70:
/* Line 1792 of yacc.c  */
#line 387 "pascal.y"
    { IGN((yyvsp[(1) - (2)])); }
    break;

  case 73:
/* Line 1792 of yacc.c  */
#line 394 "pascal.y"
    { LNK((yyvsp[(1) - (4)]),(yyvsp[(2) - (4)]));
                                                IGN((yyvsp[(2) - (4)])); LNK((yyvsp[(2) - (4)]),(yyvsp[(4) - (4)])); }
    break;

  case 74:
/* Line 1792 of yacc.c  */
#line 396 "pascal.y"
    { LNK((yyvsp[(1) - (4)]),(yyvsp[(2) - (4)]));
                                                      IGN((yyvsp[(2) - (4)])); LNK((yyvsp[(3) - (4)]),(yyvsp[(4) - (4)])); LNK((yyvsp[(2) - (4)]),(yyvsp[(4) - (4)])); }
    break;

  case 75:
/* Line 1792 of yacc.c  */
#line 398 "pascal.y"
    { LNK((yyvsp[(1) - (4)]),(yyvsp[(2) - (4)])); 
                                                    CHGTAG((yyvsp[(2) - (4)]),CTINT); UP((yyvsp[(2) - (4)]),(yyvsp[(3) - (4)])); LNK((yyvsp[(2) - (4)]),(yyvsp[(4) - (4)])); }
    break;

  case 76:
/* Line 1792 of yacc.c  */
#line 403 "pascal.y"
    {CHGTAG((yyvsp[(1) - (1)]),PDEFVARID); (yyvsp[(1) - (1)])->sym_ptr->is_global=1;  (yyval)=(yyvsp[(1) - (1)]);}
    break;

  case 77:
/* Line 1792 of yacc.c  */
#line 404 "pascal.y"
    {LNK((yyvsp[(1) - (3)]),(yyvsp[(3) - (3)]));(yyvsp[(3) - (3)])->sym_ptr->is_global=1; (yyval)=(yyvsp[(3) - (3)]);  }
    break;

  case 78:
/* Line 1792 of yacc.c  */
#line 407 "pascal.y"
    {(yyval)=(yyvsp[(1) - (1)]); CHGTYPE((yyvsp[(1) - (1)]),(yyvsp[(1) - (1)])); }
    break;

  case 79:
/* Line 1792 of yacc.c  */
#line 408 "pascal.y"
    {(yyval)=(yyvsp[(1) - (1)]); CHGTAG((yyvsp[(1) - (1)]),PID); CHGID((yyvsp[(1) - (1)]),PID); CHGTYPE((yyvsp[(1) - (1)]),(yyvsp[(1) - (1)])); }
    break;

  case 83:
/* Line 1792 of yacc.c  */
#line 417 "pascal.y"
    { CHGTAG((yyvsp[(1) - (2)]),PBEGIN); }
    break;

  case 84:
/* Line 1792 of yacc.c  */
#line 419 "pascal.y"
    { CHGTAG((yyvsp[(1) - (4)]),PBEGIN); IGN((yyvsp[(3) - (4)])); }
    break;

  case 86:
/* Line 1792 of yacc.c  */
#line 423 "pascal.y"
    {IGN((yyvsp[(2) - (3)])); }
    break;

  case 87:
/* Line 1792 of yacc.c  */
#line 426 "pascal.y"
    {IGN((yyvsp[(1) - (1)])); SYM((yyvsp[(1) - (1)]))->scan_count--; localize((yyvsp[(1) - (1)]));  }
    break;

  case 88:
/* Line 1792 of yacc.c  */
#line 427 "pascal.y"
    {IGN((yyvsp[(1) - (1)])); }
    break;

  case 89:
/* Line 1792 of yacc.c  */
#line 428 "pascal.y"
    {IGN((yyvsp[(2) - (3)])); IGN((yyvsp[(3) - (3)])); }
    break;

  case 91:
/* Line 1792 of yacc.c  */
#line 433 "pascal.y"
    { IGN((yyvsp[(1) - (2)])); }
    break;

  case 94:
/* Line 1792 of yacc.c  */
#line 441 "pascal.y"
    { LNK((yyvsp[(1) - (4)]),(yyvsp[(2) - (4)])); CHGTAG((yyvsp[(2) - (4)]),CTLOCAL); LNK((yyvsp[(2) - (4)]),(yyvsp[(4) - (4)])); }
    break;

  case 95:
/* Line 1792 of yacc.c  */
#line 443 "pascal.y"
    { LNK((yyvsp[(1) - (4)]),(yyvsp[(2) - (4)])); IGN((yyvsp[(2) - (4)])); LNK((yyvsp[(2) - (4)]),(yyvsp[(4) - (4)])); }
    break;

  case 96:
/* Line 1792 of yacc.c  */
#line 445 "pascal.y"
    { LNK((yyvsp[(1) - (4)]),(yyvsp[(2) - (4)])); IGN((yyvsp[(2) - (4)])); LNK((yyvsp[(3) - (4)]),(yyvsp[(4) - (4)])); LNK((yyvsp[(2) - (4)]),(yyvsp[(4) - (4)])); }
    break;

  case 97:
/* Line 1792 of yacc.c  */
#line 447 "pascal.y"
    { LNK((yyvsp[(1) - (4)]),(yyvsp[(2) - (4)])); CHGTAG((yyvsp[(2) - (4)]),CTINT); 
                   UP((yyvsp[(2) - (4)]),(yyvsp[(3) - (4)])); LNK((yyvsp[(2) - (4)]),(yyvsp[(4) - (4)])); }
    break;

  case 98:
/* Line 1792 of yacc.c  */
#line 450 "pascal.y"
    {CHGTAG((yyvsp[(1) - (1)]),PDEFVARID); (yyval)=(yyvsp[(1) - (1)]); }
    break;

  case 99:
/* Line 1792 of yacc.c  */
#line 451 "pascal.y"
    {LNK((yyvsp[(1) - (3)]),(yyvsp[(3) - (3)]));(yyval)=(yyvsp[(3) - (3)]); }
    break;

  case 100:
/* Line 1792 of yacc.c  */
#line 454 "pascal.y"
    {(yyval)=(yyvsp[(1) - (1)]); localize((yyvsp[(1) - (1)])); }
    break;

  case 101:
/* Line 1792 of yacc.c  */
#line 455 "pascal.y"
    {(yyval)=(yyvsp[(1) - (1)]); CHGTAG((yyvsp[(1) - (1)]),PID); 
            CHGID((yyvsp[(1) - (1)]),PID); localize((yyvsp[(1) - (1)])); }
    break;

  case 102:
/* Line 1792 of yacc.c  */
#line 463 "pascal.y"
    {IGN((yyvsp[(3) - (6)])); IGN((yyvsp[(6) - (6)]));  wend((yyvsp[(4) - (6)]),(yyvsp[(5) - (6)])); wsemicolon((yyvsp[(4) - (6)]),(yyvsp[(5) - (6)])); 
           scope_close(); }
    break;

  case 103:
/* Line 1792 of yacc.c  */
#line 466 "pascal.y"
    { IGN((yyvsp[(5) - (5)])); wend((yyvsp[(3) - (5)]),(yyvsp[(4) - (5)])); wsemicolon((yyvsp[(3) - (5)]),(yyvsp[(4) - (5)]));  scope_close(); }
    break;

  case 104:
/* Line 1792 of yacc.c  */
#line 467 "pascal.y"
    { scope_close(); }
    break;

  case 105:
/* Line 1792 of yacc.c  */
#line 470 "pascal.y"
    {function=1; }
    break;

  case 106:
/* Line 1792 of yacc.c  */
#line 471 "pascal.y"
    {function=0; wreturn((yyvsp[(4) - (6)]), 1,NULL); IGN((yyvsp[(6) - (6)]));
               wsemicolon((yyvsp[(4) - (6)]),(yyvsp[(5) - (6)])); scope_close(); }
    break;

  case 107:
/* Line 1792 of yacc.c  */
#line 473 "pascal.y"
    {function=1; }
    break;

  case 108:
/* Line 1792 of yacc.c  */
#line 475 "pascal.y"
    { function=0; 
            if (!wlocal_value((yyvsp[(1) - (7)]),(yyvsp[(3) - (7)]),(yyvsp[(6) - (7)])))
	    { IGN((yyvsp[(3) - (7)])); wreturn((yyvsp[(5) - (7)]),1,NULL); }
	    wsemicolon((yyvsp[(5) - (7)]),(yyvsp[(6) - (7)]));
	    IGN((yyvsp[(7) - (7)]));
	    scope_close();
	  }
    break;

  case 109:
/* Line 1792 of yacc.c  */
#line 484 "pascal.y"
    {scope_open(); (yyval)=(yyvsp[(1) - (1)]); START_PARAM; }
    break;

  case 110:
/* Line 1792 of yacc.c  */
#line 485 "pascal.y"
    {scope_open(); (yyval)=(yyvsp[(1) - (1)]); START_PARAM; }
    break;

  case 111:
/* Line 1792 of yacc.c  */
#line 486 "pascal.y"
    {scope_open(); (yyval)=(yyvsp[(1) - (1)]); START_PARAM; }
    break;

  case 112:
/* Line 1792 of yacc.c  */
#line 490 "pascal.y"
    { LNK((yyvsp[(1) - (3)]),(yyvsp[(3) - (3)])); CHGSNO((yyvsp[(1) - (3)]),(yyvsp[(2) - (3)])); CHGTYPE((yyvsp[(2) - (3)]),(yyvsp[(1) - (3)])); CHGID((yyvsp[(2) - (3)]),PPROCID); 
           CHGVALUE((yyvsp[(2) - (3)]),1); IGN((yyvsp[(3) - (3)])); }
    break;

  case 113:
/* Line 1792 of yacc.c  */
#line 493 "pascal.y"
    { LNK((yyvsp[(1) - (6)]),(yyvsp[(3) - (6)])); CHGSNO((yyvsp[(1) - (6)]),(yyvsp[(2) - (6)])); CHGTYPE((yyvsp[(2) - (6)]),(yyvsp[(1) - (6)])); CHGID((yyvsp[(2) - (6)]),PPROCID); 
            CHGVALUE((yyvsp[(2) - (6)]),param_mask); LNK((yyvsp[(4) - (6)]),(yyvsp[(5) - (6)])); IGN((yyvsp[(6) - (6)])); }
    break;

  case 114:
/* Line 1792 of yacc.c  */
#line 498 "pascal.y"
    {(yyval)=(yyvsp[(2) - (5)]); LNK((yyvsp[(1) - (5)]),(yyvsp[(3) - (5)])); CHGSNO((yyvsp[(1) - (5)]),(yyvsp[(2) - (5)])); CHGTYPE((yyvsp[(2) - (5)]),(yyvsp[(1) - (5)]));
           CHGID((yyvsp[(2) - (5)]),PFUNCID); CHGVALUE((yyvsp[(2) - (5)]),1);IGN((yyvsp[(3) - (5)])); LNK((yyvsp[(3) - (5)]),(yyvsp[(5) - (5)])); IGN((yyvsp[(5) - (5)])); }
    break;

  case 115:
/* Line 1792 of yacc.c  */
#line 501 "pascal.y"
    {(yyval)=(yyvsp[(2) - (8)]); LNK((yyvsp[(1) - (8)]),(yyvsp[(3) - (8)])); CHGSNO((yyvsp[(1) - (8)]),(yyvsp[(2) - (8)]));
	    CHGTYPE((yyvsp[(2) - (8)]),(yyvsp[(1) - (8)])); CHGID((yyvsp[(2) - (8)]),PFUNCID); CHGVALUE((yyvsp[(2) - (8)]),param_mask); 
            LNK((yyvsp[(4) - (8)]),(yyvsp[(5) - (8)])); LNK((yyvsp[(5) - (8)]),(yyvsp[(6) - (8)])); IGN((yyvsp[(6) - (8)])); LNK((yyvsp[(6) - (8)]),(yyvsp[(8) - (8)])); IGN((yyvsp[(8) - (8)])); }
    break;

  case 116:
/* Line 1792 of yacc.c  */
#line 506 "pascal.y"
    {(yyval)=(yyvsp[(1) - (1)]); }
    break;

  case 117:
/* Line 1792 of yacc.c  */
#line 508 "pascal.y"
    { LNK((yyvsp[(1) - (3)]),(yyvsp[(2) - (3)])); CHGTAG((yyvsp[(2) - (3)]),PCOMMA); (yyval)=(yyvsp[(3) - (3)]); }
    break;

  case 118:
/* Line 1792 of yacc.c  */
#line 512 "pascal.y"
    { LNK((yyvsp[(1) - (3)]),(yyvsp[(2) - (3)])); IGN((yyvsp[(2) - (3)])); (yyval)=(yyvsp[(2) - (3)]); }
    break;

  case 119:
/* Line 1792 of yacc.c  */
#line 515 "pascal.y"
    {(yyval)=(yyvsp[(1) - (1)]); }
    break;

  case 120:
/* Line 1792 of yacc.c  */
#line 516 "pascal.y"
    {LNK((yyvsp[(1) - (3)]),(yyvsp[(3) - (3)]));(yyval)=(yyvsp[(3) - (3)]); }
    break;

  case 121:
/* Line 1792 of yacc.c  */
#line 519 "pascal.y"
    {NEXT_PARAM; CHGTAG((yyvsp[(1) - (1)]),PDEFPARAMID); (yyval)=(yyvsp[(1) - (1)]); }
    break;

  case 122:
/* Line 1792 of yacc.c  */
#line 520 "pascal.y"
    {REF_PARAM; NEXT_PARAM; IGN((yyvsp[(1) - (2)]));
        CHGTAG((yyvsp[(2) - (2)]),PDEFREFID);CHGID((yyvsp[(2) - (2)]),CREFID); (yyval)=(yyvsp[(2) - (2)]); }
    break;

  case 123:
/* Line 1792 of yacc.c  */
#line 525 "pascal.y"
    {CHGTAG((yyvsp[(1) - (4)]),PCALLID); (yyval)=(yyvsp[(1) - (4)]); 
	    UP((yyvsp[(2) - (4)]),(yyvsp[(1) - (4)])); pchar2string((yyvsp[(1) - (4)]),(yyvsp[(3) - (4)])); }
    break;

  case 124:
/* Line 1792 of yacc.c  */
#line 528 "pascal.y"
    {(yyval)=(yyvsp[(1) - (4)]); UP((yyvsp[(2) - (4)]),(yyvsp[(1) - (4)])); pchar2string((yyvsp[(1) - (4)]),(yyvsp[(3) - (4)])); }
    break;

  case 125:
/* Line 1792 of yacc.c  */
#line 529 "pascal.y"
    {CHGTAG((yyvsp[(1) - (1)]),PCALLID); (yyval)=(yyvsp[(1) - (1)]); }
    break;

  case 126:
/* Line 1792 of yacc.c  */
#line 530 "pascal.y"
    { (yyval)=(yyvsp[(1) - (1)]); }
    break;

  case 127:
/* Line 1792 of yacc.c  */
#line 534 "pascal.y"
    {CHGTAG((yyvsp[(1) - (4)]),PCALLID); (yyval)=(yyvsp[(1) - (4)]); UP((yyvsp[(2) - (4)]),(yyvsp[(1) - (4)]));  pchar2string((yyvsp[(1) - (4)]),(yyvsp[(3) - (4)])); }
    break;

  case 128:
/* Line 1792 of yacc.c  */
#line 536 "pascal.y"
    { (yyval)=(yyvsp[(4) - (4)]); UP((yyvsp[(2) - (4)]),(yyvsp[(1) - (4)])); pchar2string((yyvsp[(1) - (4)]),(yyvsp[(3) - (4)])); }
    break;

  case 129:
/* Line 1792 of yacc.c  */
#line 537 "pascal.y"
    {CHGTAG((yyvsp[(1) - (1)]),PCALLID);(yyval)=(yyvsp[(1) - (1)]); }
    break;

  case 130:
/* Line 1792 of yacc.c  */
#line 538 "pascal.y"
    {(yyval)=(yyvsp[(1) - (1)]); }
    break;

  case 131:
/* Line 1792 of yacc.c  */
#line 542 "pascal.y"
    {(yyval)=(yyvsp[(1) - (1)]); }
    break;

  case 132:
/* Line 1792 of yacc.c  */
#line 544 "pascal.y"
    {if ((yyvsp[(3) - (3)])==NULL) (yyval)=(yyvsp[(1) - (3)]); else if ((yyvsp[(1) - (3)])==NULL) (yyval)=(yyvsp[(3) - (3)]); 
       else (yyval)=join(PCOMMA,(yyvsp[(1) - (3)]),(yyvsp[(3) - (3)]),0); }
    break;

  case 133:
/* Line 1792 of yacc.c  */
#line 548 "pascal.y"
    {(yyval)=(yyvsp[(1) - (1)]); }
    break;

  case 134:
/* Line 1792 of yacc.c  */
#line 549 "pascal.y"
    {(yyval)=(yyvsp[(1) - (1)]); }
    break;

  case 135:
/* Line 1792 of yacc.c  */
#line 550 "pascal.y"
    {(yyval)=(yyvsp[(1) - (1)]); }
    break;

  case 136:
/* Line 1792 of yacc.c  */
#line 551 "pascal.y"
    {(yyval)=(yyvsp[(1) - (1)]); }
    break;

  case 137:
/* Line 1792 of yacc.c  */
#line 555 "pascal.y"
    {(yyval)=(yyvsp[(2) - (3)]); }
    break;

  case 138:
/* Line 1792 of yacc.c  */
#line 558 "pascal.y"
    {(yyval)=(yyvsp[(1) - (1)]); }
    break;

  case 139:
/* Line 1792 of yacc.c  */
#line 560 "pascal.y"
    {(yyval)=join(PSEMICOLON,(yyvsp[(1) - (3)]),(yyvsp[(3) - (3)]),0); }
    break;

  case 140:
/* Line 1792 of yacc.c  */
#line 564 "pascal.y"
    {(yyval)=(yyvsp[(1) - (1)]); }
    break;

  case 141:
/* Line 1792 of yacc.c  */
#line 565 "pascal.y"
    { clabel((yyvsp[(1) - (3)]),0);(yyval)=join(PCOLON,(yyvsp[(1) - (3)]),(yyvsp[(3) - (3)]),0); }
    break;

  case 142:
/* Line 1792 of yacc.c  */
#line 567 "pascal.y"
    { IGN((yyvsp[(1) - (3)])); IGN((yyvsp[(2) - (3)])); (yyval)=join(PCOLON,(yyvsp[(1) - (3)]),(yyvsp[(3) - (3)]),0); }
    break;

  case 143:
/* Line 1792 of yacc.c  */
#line 570 "pascal.y"
    { clabel((yyvsp[(2) - (2)]),1); (yyval)=join(PGOTO,(yyvsp[(2) - (2)]),NULL,0); }
    break;

  case 144:
/* Line 1792 of yacc.c  */
#line 571 "pascal.y"
    { IGN((yyvsp[(1) - (2)])); (yyval)=(yyvsp[(2) - (2)]); }
    break;

  case 145:
/* Line 1792 of yacc.c  */
#line 572 "pascal.y"
    { (yyval)=(yyvsp[(2) - (2)]); }
    break;

  case 146:
/* Line 1792 of yacc.c  */
#line 573 "pascal.y"
    { if (function) clabel((yyvsp[(1) - (1)]),1); 
           else { CHGTAG((yyvsp[(1) - (1)]),CPROCRETURN);(yyvsp[(1) - (1)])->sym_ptr->goto_count++; }
                  (yyval)=(yyvsp[(1) - (1)]); }
    break;

  case 150:
/* Line 1792 of yacc.c  */
#line 582 "pascal.y"
    { seq((yyvsp[(1) - (3)]),(yyvsp[(3) - (3)])); (yyval)=(yyvsp[(1) - (3)]); }
    break;

  case 158:
/* Line 1792 of yacc.c  */
#line 591 "pascal.y"
    {(yyval)=join(CEMPTY,NULL,NULL,0); }
    break;

  case 159:
/* Line 1792 of yacc.c  */
#line 593 "pascal.y"
    {(yyval)=(yyvsp[(2) - (3)]); pvar_string((yyvsp[(1) - (3)]),(yyvsp[(3) - (3)]));}
    break;

  case 160:
/* Line 1792 of yacc.c  */
#line 594 "pascal.y"
    {(yyval)=(yyvsp[(2) - (3)]); pvar_string((yyvsp[(1) - (3)]),(yyvsp[(3) - (3)])); }
    break;

  case 161:
/* Line 1792 of yacc.c  */
#line 596 "pascal.y"
    {(yyval)=(yyvsp[(2) - (5)]);  pvar_string((yyvsp[(1) - (5)]),(yyvsp[(4) - (5)])); }
    break;

  case 162:
/* Line 1792 of yacc.c  */
#line 599 "pascal.y"
    { (yyval)=(yyvsp[(1) - (3)]); }
    break;

  case 163:
/* Line 1792 of yacc.c  */
#line 600 "pascal.y"
    {(yyval)=(yyvsp[(1) - (3)]); }
    break;

  case 164:
/* Line 1792 of yacc.c  */
#line 602 "pascal.y"
    {(yyval)=join(CRETURN,NULL,NULL,0);  }
    break;

  case 165:
/* Line 1792 of yacc.c  */
#line 603 "pascal.y"
    {(yyval)=(yyvsp[(1) - (1)]); }
    break;

  case 166:
/* Line 1792 of yacc.c  */
#line 604 "pascal.y"
    {(yyval)=(yyvsp[(1) - (1)]); }
    break;

  case 170:
/* Line 1792 of yacc.c  */
#line 611 "pascal.y"
    {(yyval)=join(PBEGIN,(yyvsp[(2) - (3)]),NULL,0); wsemicolon((yyvsp[(2) - (3)]),(yyvsp[(3) - (3)])); }
    break;

  case 173:
/* Line 1792 of yacc.c  */
#line 615 "pascal.y"
    {(yyval)=join(PIF,(yyvsp[(4) - (4)]),NULL,0); }
    break;

  case 174:
/* Line 1792 of yacc.c  */
#line 617 "pascal.y"
    {wsemicolon((yyvsp[(4) - (6)]),(yyvsp[(5) - (6)]));  (yyval)=join(PELSE,(yyvsp[(4) - (6)]),(yyvsp[(6) - (6)]),0); }
    break;

  case 175:
/* Line 1792 of yacc.c  */
#line 620 "pascal.y"
    {LNK((yyvsp[(1) - (5)]),(yyvsp[(3) - (5)]));
                wsemicolon((yyvsp[(4) - (5)]),(yyvsp[(5) - (5)]));(yyval)=join(PCASE,(yyvsp[(4) - (5)]),NULL,0); }
    break;

  case 176:
/* Line 1792 of yacc.c  */
#line 623 "pascal.y"
    {LNK((yyvsp[(1) - (6)]),(yyvsp[(3) - (6)]));(yyval)=join(PCASE,(yyvsp[(4) - (6)]),NULL,0); }
    break;

  case 178:
/* Line 1792 of yacc.c  */
#line 627 "pascal.y"
    {(yyval)=join(CCASE,(yyvsp[(1) - (3)]),(yyvsp[(3) - (3)]),0); 
           wsemicolon((yyvsp[(1) - (3)]),(yyvsp[(2) - (3)])); CHGTAG((yyvsp[(2) - (3)]),CBREAK); UP((yyvsp[(2) - (3)]),(yyvsp[(1) - (3)])); }
    break;

  case 179:
/* Line 1792 of yacc.c  */
#line 630 "pascal.y"
    {(yyval)=join(CCASE,(yyvsp[(1) - (3)]),(yyvsp[(3) - (3)]),0); /* etex parses same module twice */ }
    break;

  case 180:
/* Line 1792 of yacc.c  */
#line 634 "pascal.y"
    { (yyval)=(yyvsp[(2) - (2)]); }
    break;

  case 181:
/* Line 1792 of yacc.c  */
#line 635 "pascal.y"
    {(yyval)=(yyvsp[(2) - (2)]); }
    break;

  case 182:
/* Line 1792 of yacc.c  */
#line 638 "pascal.y"
    {winsert_case((yyvsp[(1) - (2)]), (yyvsp[(2) - (2)])); }
    break;

  case 183:
/* Line 1792 of yacc.c  */
#line 639 "pascal.y"
    {winsert_case((yyvsp[(1) - (2)]),(yyvsp[(2) - (2)]));
             CHGTAG((yyvsp[(2) - (2)]),CCOLON); CHGTEXT((yyvsp[(2) - (2)]),": "); }
    break;

  case 185:
/* Line 1792 of yacc.c  */
#line 641 "pascal.y"
    { winsert_case((yyvsp[(1) - (2)]),(yyvsp[(2) - (2)])); }
    break;

  case 187:
/* Line 1792 of yacc.c  */
#line 644 "pascal.y"
    { (yyval)=(yyvsp[(1) - (1)]); }
    break;

  case 188:
/* Line 1792 of yacc.c  */
#line 645 "pascal.y"
    { USE_NMACRO((yyvsp[(1) - (1)])); (yyval)=(yyvsp[(1) - (1)]); }
    break;

  case 189:
/* Line 1792 of yacc.c  */
#line 646 "pascal.y"
    { USE_NMACRO((yyvsp[(3) - (3)])); (yyval)=(yyvsp[(1) - (3)]); }
    break;

  case 190:
/* Line 1792 of yacc.c  */
#line 647 "pascal.y"
    {USE_NMACRO((yyvsp[(1) - (3)])); USE_NMACRO((yyvsp[(3) - (3)]));  (yyval)=(yyvsp[(1) - (3)]); }
    break;

  case 191:
/* Line 1792 of yacc.c  */
#line 648 "pascal.y"
    { USE_NMACRO((yyvsp[(1) - (3)])); (yyval)=(yyvsp[(1) - (3)]); }
    break;

  case 192:
/* Line 1792 of yacc.c  */
#line 650 "pascal.y"
    { USE_NMACRO((yyvsp[(1) - (5)])); USE_NMACRO((yyvsp[(3) - (5)])); USE_NMACRO((yyvsp[(5) - (5)]));(yyval)=(yyvsp[(1) - (5)]);  /* eTeX */ }
    break;

  case 193:
/* Line 1792 of yacc.c  */
#line 651 "pascal.y"
    {USE_NMACRO((yyvsp[(2) - (2)])); (yyval)=NULL; }
    break;

  case 194:
/* Line 1792 of yacc.c  */
#line 652 "pascal.y"
    {(yyval)=NULL; }
    break;

  case 195:
/* Line 1792 of yacc.c  */
#line 654 "pascal.y"
    {USE_NMACRO((yyvsp[(2) - (4)])); USE_NMACRO((yyvsp[(4) - (4)])); (yyval)=NULL; }
    break;

  case 199:
/* Line 1792 of yacc.c  */
#line 660 "pascal.y"
    {LNK((yyvsp[(1) - (4)]),(yyvsp[(3) - (4)])); (yyval)=join(PWHILE,(yyvsp[(4) - (4)]),NULL,0); }
    break;

  case 200:
/* Line 1792 of yacc.c  */
#line 663 "pascal.y"
    { wsemicolon((yyvsp[(2) - (4)]),(yyvsp[(3) - (4)])); (yyval)=join(PREPEAT,(yyvsp[(2) - (4)]),NULL,0); }
    break;

  case 201:
/* Line 1792 of yacc.c  */
#line 666 "pascal.y"
    { for_loop_variable((yyvsp[(2) - (8)]),(yyvsp[(1) - (8)])->line_no,0,0); 
                DBG(dbgstmt,"for variable %s, limit variable in line %d\n",
                SYM((yyvsp[(2) - (8)]))->name,(yyvsp[(2) - (8)])->line_no);
                (yyval)=join(PFOR,(yyvsp[(8) - (8)]),NULL,0);LNK((yyvsp[(1) - (8)]),(yyvsp[(5) - (8)]));LNK((yyvsp[(5) - (8)]),(yyvsp[(7) - (8)])); }
    break;

  case 202:
/* Line 1792 of yacc.c  */
#line 671 "pascal.y"
    { for_loop_variable((yyvsp[(2) - (8)]),(yyvsp[(1) - (8)])->line_no,(yyvsp[(6) - (8)])->value,1); 
                DBG(dbgstmt,"for variable %s, limit up in line %d\n",
                SYM((yyvsp[(2) - (8)]))->name,(yyvsp[(2) - (8)])->line_no);
                (yyval)=join(PFOR,(yyvsp[(8) - (8)]),NULL,0);LNK((yyvsp[(1) - (8)]),(yyvsp[(5) - (8)]));LNK((yyvsp[(5) - (8)]),(yyvsp[(7) - (8)])); }
    break;

  case 203:
/* Line 1792 of yacc.c  */
#line 676 "pascal.y"
    { for_loop_variable((yyvsp[(2) - (8)]),(yyvsp[(1) - (8)])->line_no,(yyvsp[(6) - (8)])->value,-1); 
                DBG(dbgstmt,"for variable %s, limit down in line %d\n",
                SYM((yyvsp[(2) - (8)]))->name,(yyvsp[(2) - (8)])->line_no);
                (yyval)=join(PFOR,(yyvsp[(8) - (8)]),NULL,0);LNK((yyvsp[(1) - (8)]),(yyvsp[(5) - (8)]));LNK((yyvsp[(5) - (8)]),(yyvsp[(7) - (8)])); }
    break;

  case 208:
/* Line 1792 of yacc.c  */
#line 684 "pascal.y"
    { USE((yyvsp[(1) - (1)])); }
    break;

  case 209:
/* Line 1792 of yacc.c  */
#line 685 "pascal.y"
    { USE((yyvsp[(1) - (1)])); }
    break;

  case 215:
/* Line 1792 of yacc.c  */
#line 698 "pascal.y"
    {(yyval)=join(PSQOPEN,(yyvsp[(1) - (4)]),(yyvsp[(3) - (4)]),0); }
    break;

  case 216:
/* Line 1792 of yacc.c  */
#line 700 "pascal.y"
    {(yyval)=join(PSQOPEN,(yyvsp[(1) - (4)]),(yyvsp[(3) - (4)]),0); }
    break;

  case 217:
/* Line 1792 of yacc.c  */
#line 702 "pascal.y"
    {(yyval)=join(PSQOPEN,(yyvsp[(1) - (4)]),(yyvsp[(3) - (4)]),0); }
    break;

  case 218:
/* Line 1792 of yacc.c  */
#line 706 "pascal.y"
    {(yyval)=join(PDOT,(yyvsp[(1) - (3)]),(yyvsp[(3) - (3)]),0); }
    break;

  case 219:
/* Line 1792 of yacc.c  */
#line 709 "pascal.y"
    {(yyval)=join(PUP,(yyvsp[(1) - (2)]),NULL,0); }
    break;

  case 220:
/* Line 1792 of yacc.c  */
#line 712 "pascal.y"
    {(yyval)=(yyvsp[(1) - (1)]); }
    break;

  case 221:
/* Line 1792 of yacc.c  */
#line 714 "pascal.y"
    { pvar_string((yyvsp[(1) - (3)]),(yyvsp[(3) - (3)])); (yyval)=join((yyvsp[(2) - (3)])->tag,(yyvsp[(1) - (3)]),(yyvsp[(3) - (3)]),0); }
    break;

  case 222:
/* Line 1792 of yacc.c  */
#line 716 "pascal.y"
    { pvar_string((yyvsp[(1) - (3)]),(yyvsp[(3) - (3)])); (yyval)=join(PEQ,(yyvsp[(1) - (3)]),(yyvsp[(3) - (3)]),0); }
    break;

  case 229:
/* Line 1792 of yacc.c  */
#line 721 "pascal.y"
    {(yyval)=(yyvsp[(1) - (1)]); }
    break;

  case 230:
/* Line 1792 of yacc.c  */
#line 722 "pascal.y"
    {(yyval)=(yyvsp[(2) - (2)]); }
    break;

  case 231:
/* Line 1792 of yacc.c  */
#line 723 "pascal.y"
    {(yyval)=(yyvsp[(2) - (3)]); }
    break;

  case 232:
/* Line 1792 of yacc.c  */
#line 724 "pascal.y"
    {(yyval)=(yyvsp[(2) - (4)]); }
    break;

  case 238:
/* Line 1792 of yacc.c  */
#line 731 "pascal.y"
    {(yyval)=(yyvsp[(1) - (1)]); }
    break;

  case 239:
/* Line 1792 of yacc.c  */
#line 732 "pascal.y"
    {(yyval)=(yyvsp[(2) - (3)]); }
    break;

  case 241:
/* Line 1792 of yacc.c  */
#line 736 "pascal.y"
    { DBG(dbgslash,"Pascal / in line %d\n",(yyvsp[(1) - (1)])->line_no); }
    break;

  case 245:
/* Line 1792 of yacc.c  */
#line 741 "pascal.y"
    {(yyval)=(yyvsp[(1) - (1)]); }
    break;

  case 246:
/* Line 1792 of yacc.c  */
#line 742 "pascal.y"
    {(yyval)=(yyvsp[(1) - (1)]); }
    break;

  case 247:
/* Line 1792 of yacc.c  */
#line 743 "pascal.y"
    {(yyval)=(yyvsp[(2) - (3)]); }
    break;

  case 249:
/* Line 1792 of yacc.c  */
#line 745 "pascal.y"
    {(yyval)=(yyvsp[(1) - (2)]); }
    break;

  case 252:
/* Line 1792 of yacc.c  */
#line 751 "pascal.y"
    { USE_NMACRO((yyvsp[(1) - (1)])); }
    break;

  case 257:
/* Line 1792 of yacc.c  */
#line 758 "pascal.y"
    {(yyval)=(yyvsp[(2) - (3)]); /* used in line 2361 */}
    break;


/* Line 1792 of yacc.c  */
#line 3139 "pascal.tab.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


/* Line 2055 of yacc.c  */
#line 761 "pascal.y"


const char *tagname(int tag)
{ return yytname[YYTRANSLATE(tag)];
}
